//
//	00 D3_SHADER_TYPE_NORMAL : ʏ
//

//#include	"def.h"
static		const	int		MAX_MATRICES = 50;


//--- WvZp --------------------------------------------------------------
float4x4	g_mtxWorld;										// World
float4x4	g_mtxViewProjection;							// View	* Projection

//--- CgFɊւ --------------------------------------------------
float4		g_vecLightDirection;							// Cǧ
float4		g_vecDiffuse;									// diffuse
float4		g_vecAmbient;									// 
int			g_iLightSw;										// 1 : CgI
float		g_fAlp;											// At@l

//--- {[Ɋւ ------------------------------------------------------
int			g_iNumBones;									// uhW
float4x3	g_mtxWorldMatrixArray[MAX_MATRICES];			// spbg


//--- eNX` ------------------------------------------------------------
texture		texDecale;						// ʏ̃eNX`

//--- TvXe[g --------------------------------------------------------
sampler	smpDecale = sampler_state			// fJ[
{
	Texture	  =	(texDecale);
	MipFilter =	LINEAR;
	MagFilter =	LINEAR;
	MinFilter =	LINEAR;
	ADDRESSU  =	WRAP;
	ADDRESSV  =	WRAP;
};


//-----------------------------------------------------------------------------
//	<<<	tH[}bg >>>
//-----------------------------------------------------------------------------
struct	VS_NOSKIN_INPUT
{
	float4	Position		: POSITION;
	float3	Normal			: NORMAL;
	float2	Tex				: TEXCOORD0;
};

struct	VS_INPUT
{
	float4	Position		: POSITION;
	float4	BlendWeights	: BLENDWEIGHT;
	float4	BlendIndices	: BLENDINDICES;
	float3	Normal			: NORMAL;
	float2	Tex				: TEXCOORD0;
};

struct	VS_OUTPUT
{
	float4	Position		: POSITION;
	float4	Color			: COLOR;
	float2	Tex				: TEXCOORD0;
	//float3	Fog			: TEXCOORD1;
};


//-----------------------------------------------------------------------------
//	<<<	{[蒸_VF[_[ >>>
//-----------------------------------------------------------------------------
VS_OUTPUT	VS(VS_INPUT	In,	uniform	int	NumBones)
{
	VS_OUTPUT	Out	= (VS_OUTPUT)0;
	int4		IndexVector			 = D3DCOLORtoUBYTE4(In.BlendIndices);
	int			IndexArray[		  4] = (int[  4])IndexVector;
	float		BlendWeightsArray[4] = (float[4])In.BlendWeights;
	float		LastWeight = 0.0f;
	float3		nor		   = 0.0f;
	 
	//--- {[ ------------------------------------------------
	for(int	iBone =	0; iBone < NumBones; iBone++)
	{
		Out.Position.xyz +=	mul(In.Position, g_mtxWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
		nor				 +=	mul(In.Normal,	 g_mtxWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
		LastWeight		 +=	BlendWeightsArray[iBone];
	}
	LastWeight		  =	1.0f - LastWeight; 
	Out.Position.xyz +=	(mul(In.Position, g_mtxWorldMatrixArray[IndexArray[NumBones]]) * LastWeight);
	nor			     += (mul(In.Normal,	  g_mtxWorldMatrixArray[IndexArray[NumBones]]) * LastWeight);
	Out.Position.w	  =	1;
	float3	bak       = Out.Position.xyz;
	Out.Position	  =	mul(Out.Position, g_mtxViewProjection);

	//---- K ---------------------------------------------------
	nor = normalize(nor);

	//--- Shade	(Ambient + etc.) ------------------------------------
	Out.Color.xyz =	g_vecAmbient.xyz + max(0.0f, dot(nor, -g_vecLightDirection.xyz)) * g_vecDiffuse.xyz;
	Out.Color.w   = g_vecDiffuse.w;

	//--- eNX` ----------------------------------------------
	Out.Tex.xy = In.Tex;

	//--- RcW(tHOp) ----------------------------------------
	//Out.Fog    = bak;

	return Out;
}


//-----------------------------------------------------------------------------
//	<<<	{[蒸_VF[_[ >>>	CgIt
//-----------------------------------------------------------------------------
VS_OUTPUT	VS_NOLIGHT(VS_INPUT	In,	uniform	int	NumBones)
{
	VS_OUTPUT	Out	= (VS_OUTPUT)0;
	int4		IndexVector			 = D3DCOLORtoUBYTE4(In.BlendIndices);
	int			IndexArray[		  4] = (int[  4])IndexVector;
	float		BlendWeightsArray[4] = (float[4])In.BlendWeights;
	float		LastWeight = 0.0f;
	float3		nor		   = 0.0f;
	 
	//--- {[ ------------------------------------------------
	for(int	iBone =	0; iBone < NumBones; iBone++)
	{
		Out.Position.xyz +=	mul(In.Position, g_mtxWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
		nor				 +=	mul(In.Normal,	 g_mtxWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
		LastWeight		 +=	BlendWeightsArray[iBone];
	}
	LastWeight		  =	1.0f - LastWeight; 
	Out.Position.xyz +=	(mul(In.Position, g_mtxWorldMatrixArray[IndexArray[NumBones]]) * LastWeight);
	nor			     += (mul(In.Normal,	  g_mtxWorldMatrixArray[IndexArray[NumBones]]) * LastWeight);
	Out.Position.w	  =	1;
	float3	bak       = Out.Position.xyz;
	Out.Position	  =	mul(Out.Position, g_mtxViewProjection);

	//---- K ---------------------------------------------------
	nor = normalize(nor);

	//--- Shade	(Ambient + etc.) ------------------------------------
	Out.Color.xyz = g_vecAmbient.xyz + g_vecDiffuse.xyz;
	Out.Color.w   = g_vecDiffuse.w;

	//--- eNX` ----------------------------------------------
	Out.Tex.xy = In.Tex;

	//--- RcW(tHOp) ----------------------------------------
	//Out.Fog    = bak;

	return Out;
}


//-----------------------------------------------------------------------------
//	<<<	{[Ȃ_VF[_[ >>>
//-----------------------------------------------------------------------------
VS_OUTPUT	VS_NOSKIN(VS_NOSKIN_INPUT In)
{
	VS_OUTPUT	Out;
 
	//--- Wϊ --------------------------------------------------
 	float4		P  = mul(In.Position, g_mtxWorld);
	Out.Position.w = 1;
	Out.Position   = mul(P,	g_mtxViewProjection);

	//--- F --------------------------------------------------------
	Out.Color.xyz =	g_vecAmbient.xyz + max(0.0f, dot(In.Normal,	-g_vecLightDirection.xyz)) * g_vecDiffuse.xyz;
	Out.Color.w   = g_vecDiffuse.w;

	//--- eNX` ----------------------------------------------
	Out.Tex.xy = In.Tex;

	//--- RcW(tHOp) ----------------------------------------
	//Out.Fog    = P;

	return Out;
}


//-----------------------------------------------------------------------------
//	<<<	{[Ȃ_VF[_[ >>>	CgIt
//-----------------------------------------------------------------------------
VS_OUTPUT	VS_NOSKIN_NOLIGHT(VS_NOSKIN_INPUT In)
{
	VS_OUTPUT	Out;
 
	//--- Wϊ --------------------------------------------------
 	float4		P  = mul(In.Position, g_mtxWorld);
	Out.Position.w = 1;
	Out.Position   = mul(P,	g_mtxViewProjection);

	//--- F --------------------------------------------------------
	Out.Color.xyz = g_vecAmbient.xyz + g_vecDiffuse.xyz;
	Out.Color.w   = g_vecDiffuse.w;

	//--- eNX` ----------------------------------------------
	Out.Tex.xy = In.Tex;

	//--- RcW(tHOp) ----------------------------------------
	//Out.Fog    = P;

	return Out;
}


//-----------------------------------------------------------------------------
//	  <<< sNZVF[_[ >>>
//-----------------------------------------------------------------------------
float4	PS(VS_OUTPUT In) : COLOR0
{

	float4	decale = tex2D(smpDecale, In.Tex) * In.Color;
	decale.a *= g_fAlp;
	return	decale;
}



//-----------------------------------------------------------------------------
//	<<<	 Techniques	>>>
//-----------------------------------------------------------------------------
VertexShader	vsArray[10] =
{	 
	// CgIt
	compile	vs_2_0 VS_NOLIGHT(0),
	compile	vs_2_0 VS_NOLIGHT(1),
	compile	vs_2_0 VS_NOLIGHT(2),
	compile	vs_2_0 VS_NOLIGHT(3),
	compile	vs_2_0 VS_NOSKIN_NOLIGHT(),

	// CgI
	compile	vs_2_0 VS(g_iNumBones),
	compile	vs_2_0 VS(g_iNumBones),
	compile	vs_2_0 VS(g_iNumBones),
	compile	vs_2_0 VS(g_iNumBones),
	compile	vs_2_0 VS_NOSKIN()
};

technique	Normal
{
	pass p0
	{
		VertexShader = (vsArray[g_iNumBones + g_iLightSw * 5]);
 		PixelShader	 = compile ps_2_0 PS();
	}
}

